/********************************************************************************
*                                                                               *
*                          T e x t   C o m m a n d s                            *
*                                                                               *
*********************************************************************************
* Copyright (C) 1998,2000 by Jeroen van der Zijp.   All Rights Reserved.        *
*********************************************************************************
* $Id: TextCommand.cpp,v 1.3 2000/07/18 06:54:57 jeroen Exp $                   *
********************************************************************************/
#include "fx.h"
#include "TextCommand.h"


/*
  Notes:
  
  - Need to keep better track of modified state of text buffer.
*/


/*******************************************************************************/

// Insert command
FXTextInsert::FXTextInsert(FXText* txt,FXint p,FXint n):
  FXTextCommand(txt,p,n){
  dirty=text->isModified();
  }


// Undo an insert removes the inserted text
void FXTextInsert::undo(){
  FXCALLOC(&buffer,FXchar,num);
  text->extractText(buffer,pos,num);
  text->removeText(pos,num);
  text->setCursorPos(pos);
  text->setModified(dirty);
  }


// Redo an insert inserts the same old text again
void FXTextInsert::redo(){
  text->insertText(pos,buffer,num);
  text->setCursorPos(pos+num);
  text->setModified(TRUE);
  FXFREE(&buffer);
  }



// Delete command
FXTextDelete::FXTextDelete(FXText* txt,FXint p,FXint n):
  FXTextCommand(txt,p,n){
  FXCALLOC(&buffer,FXchar,num);
  text->extractText(buffer,pos,num);
  dirty=text->isModified();
  }


// Undo a delete reinserts the old text
void FXTextDelete::undo(){
  text->insertText(pos,buffer,num);
  text->setCursorPos(pos+num);
  text->setModified(dirty);
  FXFREE(&buffer);
  }


// Redo a delete removes it again
void FXTextDelete::redo(){
  FXCALLOC(&buffer,FXchar,num);
  text->extractText(buffer,pos,num);
  text->removeText(pos,num);
  text->setCursorPos(pos);
  }



