/********************************************************************************
*                                                                               *
*                          T e x t   C o m m a n d s                            *
*                                                                               *
*********************************************************************************
* Copyright (C) 1998,2000 by Jeroen van der Zijp.   All Rights Reserved.        *
*********************************************************************************
* $Id: TextCommand.h,v 1.3 2000/07/18 06:54:57 jeroen Exp $                     *
********************************************************************************/
#ifndef TEXTCOMMAND_H
#define TEXTCOMMAND_H


/*******************************************************************************/

class FXText;


// Undo record for text fragment
class FXAPI FXTextCommand : public FXCommand {
protected:
  FXText *text;     // Text widget
  FXchar *buffer;   // Character buffer
  FXint   pos;      // Character position 
  FXint   num;      // Number of characters
  FXbool  dirty;    // Was text buffer dirty
public:
  FXTextCommand(FXText* txt,FXint p,FXint n):text(txt),buffer(NULL),pos(p),num(n),dirty(FALSE){}
  virtual FXuint size() const { return num; }
  virtual ~FXTextCommand(){FXFREE(&buffer);}
  };


// Insert command
class FXAPI FXTextInsert : public FXTextCommand {
public:
  FXTextInsert(FXText* txt,FXint p,FXint n);
  virtual FXString undoName() const { return "Undo insert"; }
  virtual FXString redoName() const { return "Redo insert"; }
  virtual void undo();
  virtual void redo();
  };

  
// Delete command
class FXAPI FXTextDelete : public FXTextCommand {
public:
  FXTextDelete(FXText* txt,FXint p,FXint n);
  virtual FXString undoName() const { return "Undo delete"; }
  virtual FXString redoName() const { return "Redo delete"; }
  virtual void undo();
  virtual void redo();
  };


#endif

